#define pot01 A0
#define pot02 A1

#define led01 A2 //green
#define led02 A3 //yellow

#define photoresistor A4 //-45 to 70, 550-900 in Physc Comp

#define lighting A5
#define lightSwitch 8

#define emergencySwitch 11

#define blink01 12
#define blink02 13

int photoresistorLow = 550;
int photoresistorHigh = 900;

int velocity;
int heartRate;
int emergency;
int lightFlip;

int delayTime = 250;

int light;
int dim;

void setup() {
  Serial.begin(9600); // initialize serial communications

  pinMode(pot01, INPUT); //initialize potentiometer
  pinMode(pot02, INPUT); //initialize potentiometer

  pinMode(photoresistor, INPUT); //initialize photoresistor
  
  pinMode(lightSwitch, INPUT); //initialize light switch
  pinMode(lighting, OUTPUT); //initialize LED output pin
  
  pinMode(led01, OUTPUT); //initialize LED output pin
  pinMode(led02, OUTPUT); //initialize LED output pin

  pinMode(emergencySwitch, INPUT); //initialize emergency switch

  pinMode(blink01, OUTPUT); //initialize LED output pin
  pinMode(blink02, OUTPUT); //initialize LED output pin
}

void loop() {
  velocity = analogRead(pot01);
  velocity = map(velocity,0,1023,0,25); //fastest human speed is 28 mph

  heartRate = analogRead(pot02);
  heartRate = map(heartRate,0,1023,0,240); //for a 20 year old, 200 bpm is the maximum, 100-170 is the general target range

  light = analogRead(photoresistor);
  light = map(light,photoresistorLow,photoresistorHigh,0,100);
  Serial.println(light);
  
  emergency = digitalRead(emergencySwitch);

  lightFlip = digitalRead(lightSwitch);

  if ((heartRate > 170 || heartRate < 100) || emergency == 1) {
    digitalWrite(lighting, HIGH);
    digitalWrite(blink01, HIGH);
    digitalWrite(led01, HIGH);
    delay(delayTime);
    digitalWrite(blink02, HIGH);
    digitalWrite(led02, HIGH);
    digitalWrite(blink01, LOW);
    digitalWrite(led01, LOW);
    delay(delayTime);
    digitalWrite(blink02, LOW);
    digitalWrite(led02, LOW);
  }

  if (velocity > 6) {
    digitalWrite(led02, HIGH);
  }
  
  if (velocity < 6) {
    digitalWrite(led02, LOW);
  }

  if (velocity < 3) { 
    digitalWrite(led01,HIGH);
  }

  if (velocity > 3) { 
    digitalWrite(led01,LOW);
  }

  if (emergency == 0 && lightFlip == 0 && light > 70) {
    digitalWrite(lighting, LOW);
  }
  
  if (lightFlip == 1 && light < 70 && light > 30) {
    digitalWrite(lighting, HIGH);
    delay(delayTime);
    digitalWrite(lighting, LOW);
    delay(delayTime);
  }

  if (lightFlip == 1 && light < 30) {
    digitalWrite(lighting, HIGH);
    delay(delayTime);
    digitalWrite(lighting, LOW);
  }
  
  if (light < 15) {
    digitalWrite(lighting, HIGH);
  }

    if (light > 15) {
    digitalWrite(lighting, LOW);
  }
}
